{- |
Files with text content.
-}
module System.IO.Exception.TextFile where

import System.IO.Exception.File (EIO, close, )
import Control.Monad.Exception.Synchronous (bracketT, )
import System.IO.Straight (ioToExceptionalSIO, )
import System.IO (Handle, IOMode, )
import qualified System.IO as IO


open :: FilePath -> IOMode -> EIO Handle
open name mode =
   ioToExceptionalSIO $ IO.openFile name mode

with ::
   FilePath -> IOMode -> (Handle -> EIO r) -> EIO r
with name mode =
   bracketT (open name mode) close

getChar :: Handle -> EIO Char
getChar h =
   ioToExceptionalSIO $ IO.hGetChar h

putChar :: Handle -> Char -> EIO ()
putChar h c =
   ioToExceptionalSIO $ IO.hPutChar h c
